Package org.apache.storm.daemon.nimbus

## Class Nimbus

- java.lang.Object
- - org.apache.storm.daemon.nimbus.Nimbus

- All Implemented Interfaces:
    `DaemonCommon`, `Shutdownable`, `Nimbus.Iface`

      public class Nimbus
      extends Object
      implements Nimbus.Iface, Shutdownable, DaemonCommon

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `Nimbus.StandaloneINimbus` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static SimpleVersion` | `MIN_VERSION_SUPPORT_RPC_HEARTBEAT` |
    `static Subject` | `NIMBUS_SUBJECT` |
    `static List<org.apache.storm.shade.org.apache.zookeeper.data.ACL>` | `ZK_ACLS` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `Nimbus​(Map<String,​Object> conf, INimbus inimbus, IStormClusterState stormClusterState, NimbusInfo hostPortInfo, BlobStore blobStore, TopoCache topoCache, ILeaderElector leaderElector, IGroupMappingServiceProvider groupMapper, StormMetricsRegistry metricsRegistry)` |
    `Nimbus​(Map<String,​Object> conf, INimbus inimbus, IStormClusterState stormClusterState, NimbusInfo hostPortInfo, BlobStore blobStore, ILeaderElector leaderElector, IGroupMappingServiceProvider groupMapper, StormMetricsRegistry metricsRegistry)` |
    `Nimbus​(Map<String,​Object> conf, INimbus inimbus, StormMetricsRegistry metricsRegistry)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `activate​(String topoName)` |
    `void` | `addSupervisor​(Supervisor supervisor)` | Used for local cluster.
    `boolean` | `awaitLeadership​(long timeout, TimeUnit timeUnit)` |
    `BeginDownloadResult` | `beginBlobDownload​(String key)` |
    `String` | `beginCreateBlob​(String key, SettableBlobMeta meta)` |
    `String` | `beginFileUpload()` |
    `String` | `beginUpdateBlob​(String key)` |
    `void` | `cancelBlobUpload​(String session)` |
    `void` | `checkAuthorization​(String topoName, Map<String,​Object> topoConf, String operation)` |
    `void` | `checkAuthorization​(String topoName, Map<String,​Object> topoConf, String operation, ReqContext context)` |
    `static void` | `cleanInbox​(String dirLoc, int seconds)` | Deletes jar files in dirLoc older than seconds.
    `void` | `createStateInZookeeper​(String key)` |
    `void` | `deactivate​(String topoName)` |
    `void` | `debug​(String topoName, String componentId, boolean enable, double samplingPercentage)` | Enable/disable logging the tuples generated in topology via an internal EventLogger bolt.
    `void` | `deleteBlob​(String key)` |
    `void` | `doCleanup()` | Cleanup topologies and Jars.
    `ByteBuffer` | `downloadBlobChunk​(String session)` |
    `ByteBuffer` | `downloadChunk​(String id)` |
    `Set<String>` | `filterAuthorized​(String operation, Collection<String> topoIds)` |
    `void` | `finishBlobUpload​(String session)` |
    `void` | `finishFileUpload​(String location)` |
    `void` | `forceDeleteTopoDistDir​(String topoId)` |
    `ReadableBlobMeta` | `getBlobMeta​(String key)` |
    `int` | `getBlobReplication​(String key)` |
    `ClusterSummary` | `getClusterInfo()` |
    `ComponentPageInfo` | `getComponentPageInfo​(String topoId, String componentId, String window, boolean includeSys)` |
    `List<ProfileRequest>` | `getComponentPendingProfileActions​(String id, String componentId, ProfileAction action)` |
    `HeartbeatCache` | `getHeartbeatsCache()` |
    `AtomicReference<Map<String,​Set<List<Integer>>>>` | `getIdToExecutors()` |
    `NimbusSummary` | `getLeader()` |
    `LogConfig` | `getLogConfig​(String topoId)` |
    `static List<org.apache.storm.shade.org.apache.zookeeper.data.ACL>` | `getNimbusAcls​(Map<String,​Object> conf)` |
    `String` | `getNimbusConf()` |
    `List<OwnerResourceSummary>` | `getOwnerResourceSummaries​(String owner)` |
    `SupervisorAssignments` | `getSupervisorAssignments​(String nodeId)` | Get assigned assignments for a specific supervisor
    `SupervisorPageInfo` | `getSupervisorPageInfo​(String superId, String host, boolean includeSys)` |
    `StormTopology` | `getTopology​(String id)` | Returns the compiled topology that contains ackers and metrics consumsers.
    `String` | `getTopologyConf​(String id)` |
    `TopologyHistoryInfo` | `getTopologyHistory​(String user)` |
    `TopologyInfo` | `getTopologyInfo​(String id)` |
    `TopologyInfo` | `getTopologyInfoByName​(String name)` |
    `TopologyInfo` | `getTopologyInfoByNameWithOpts​(String name, GetInfoOptions options)` |
    `TopologyInfo` | `getTopologyInfoWithOpts​(String topoId, GetInfoOptions options)` |
    `TopologyPageInfo` | `getTopologyPageInfo​(String topoId, String window, boolean includeSys)` |
    `List<TopologySummary>` | `getTopologySummaries()` |
    `TopologySummary` | `getTopologySummary​(String id)` |
    `TopologySummary` | `getTopologySummaryByName​(String name)` |
    `StormTopology` | `getUserTopology​(String id)` | Returns the user specified topology as submitted originally.
    `static int` | `getVersionForKey​(String key, NimbusInfo nimbusInfo, org.apache.storm.shade.org.apache.curator.framework.CuratorFramework zkClient)` |
    `boolean` | `isRemoteBlobExists​(String blobKey)` | Decide if the blob is removed from cluster.
    `boolean` | `isTopologyNameAllowed​(String name)` |
    `boolean` | `isWaiting()` |
    `void` | `killTopology​(String name)` |
    `void` | `killTopologyWithOpts​(String topoName, KillOptions options)` |
    `static Nimbus` | `launch​(INimbus inimbus)` |
    `void` | `launchServer()` |
    `ListBlobsResult` | `listBlobs​(String session)` |
    `static void` | `main​(String[] args)` |
    `void` | `processWorkerMetrics​(WorkerMetrics metrics)` |
    `void` | `rebalance​(String topoName, RebalanceOptions options)` |
    `void` | `rmDependencyJarsInTopology​(String topoId)` |
    `void` | `rmTopologyKeys​(String topoId)` |
    `void` | `sendSupervisorWorkerHeartbeat​(SupervisorWorkerHeartbeat hb)` | Send supervisor local worker heartbeat when a supervisor is unreachable
    `void` | `sendSupervisorWorkerHeartbeats​(SupervisorWorkerHeartbeats heartbeats)` | Send supervisor worker heartbeats for a specific supervisor
    `void` | `setAuthorizationHandler​(IAuthorizer authorizationHandler)` |
    `void` | `setBlobMeta​(String key, SettableBlobMeta meta)` |
    `void` | `setLogConfig​(String topoId, LogConfig config)` |
    `static void` | `setUpAckerExecutorConfigs​(String topoName, Map<String,​Object> totalConfToSave, Map<String,​Object> totalConf, int estimatedNumWorker)` |
    `void` | `setWorkerProfiler​(String topoId, ProfileRequest profileRequest)` |
    `void` | `shutdown()` |
    `void` | `submitTopology​(String name, String uploadedJarLocation, String jsonConf, StormTopology topology)` |
    `void` | `submitTopologyWithOpts​(String topoName, String uploadedJarLocation, String jsonConf, StormTopology topology, SubmitOptions options)` |
    `static Set<String>` | `topoIdsToClean​(IStormClusterState state, BlobStore store, Map<String,​Object> conf)` |
    `static List<String>` | `topologiesOnSupervisor​(Map<String,​Assignment> assignments, String supervisorId)` |
    `int` | `updateBlobReplication​(String key, int replication)` |
    `void` | `uploadBlobChunk​(String session, ByteBuffer chunk)` |
    `void` | `uploadChunk​(String location, ByteBuffer chunk)` |
    `void` | `uploadNewCredentials​(String topoName, Credentials credentials)` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### ZK_ACLS

          public static final List<org.apache.storm.shade.org.apache.zookeeper.data.ACL> ZK_ACLS

    - #### MIN_VERSION_SUPPORT_RPC_HEARTBEAT

          public static final SimpleVersion MIN_VERSION_SUPPORT_RPC_HEARTBEAT

    - #### NIMBUS_SUBJECT

          public static final Subject NIMBUS_SUBJECT

  - ### Constructor Detail

    - #### Nimbus

          public Nimbus​(Map<String,​Object> conf,
                        INimbus inimbus,
                        StormMetricsRegistry metricsRegistry)
                 throws Exception

      Throws:
        `Exception`

    - #### Nimbus

          public Nimbus​(Map<String,​Object> conf,
                        INimbus inimbus,
                        IStormClusterState stormClusterState,
                        NimbusInfo hostPortInfo,
                        BlobStore blobStore,
                        ILeaderElector leaderElector,
                        IGroupMappingServiceProvider groupMapper,
                        StormMetricsRegistry metricsRegistry)
                 throws Exception

      Throws:
        `Exception`

    - #### Nimbus

          public Nimbus​(Map<String,​Object> conf,
                        INimbus inimbus,
                        IStormClusterState stormClusterState,
                        NimbusInfo hostPortInfo,
                        BlobStore blobStore,
                        TopoCache topoCache,
                        ILeaderElector leaderElector,
                        IGroupMappingServiceProvider groupMapper,
                        StormMetricsRegistry metricsRegistry)
                 throws Exception

      Throws:
        `Exception`

  - ### Method Detail

    - #### getNimbusAcls

          public static List<org.apache.storm.shade.org.apache.zookeeper.data.ACL> getNimbusAcls​(Map<String,​Object> conf)

    - #### getVersionForKey

          public static int getVersionForKey​(String key,
                                             NimbusInfo nimbusInfo,
                                             org.apache.storm.shade.org.apache.curator.framework.CuratorFramework zkClient)
                                      throws KeyNotFoundException

      Throws:
        `KeyNotFoundException`

    - #### topoIdsToClean

          public static Set<String> topoIdsToClean​(IStormClusterState state,
                                                   BlobStore store,
                                                   Map<String,​Object> conf)

    - #### cleanInbox

          public static void cleanInbox​(String dirLoc,
                                        int seconds)

      Deletes jar files in dirLoc older than seconds.
      Parameters:
        `dirLoc` - the location to look in for file
        `seconds` - how old is too old and should be deleted

    - #### topologiesOnSupervisor

          public static List<String> topologiesOnSupervisor​(Map<String,​Assignment> assignments,
                                                            String supervisorId)

    - #### launchServer

          public void launchServer()
                            throws Exception

      Throws:
        `Exception`

    - #### launch

          public static Nimbus launch​(INimbus inimbus)
                               throws Exception

      Throws:
        `Exception`

    - #### main

          public static void main​(String[] args)
                           throws Exception

      Throws:
        `Exception`

    - #### setAuthorizationHandler

          public void setAuthorizationHandler​(IAuthorizer authorizationHandler)

    - #### getHeartbeatsCache

          public HeartbeatCache getHeartbeatsCache()

    - #### getIdToExecutors

          public AtomicReference<Map<String,​Set<List<Integer>>>> getIdToExecutors()

    - #### addSupervisor

          public void addSupervisor​(Supervisor supervisor)

      Used for local cluster.
      Parameters:
        `supervisor` - `Supervisor`

    - #### checkAuthorization

          public void checkAuthorization​(String topoName,
                                         Map<String,​Object> topoConf,
                                         String operation)
                                  throws AuthorizationException

      Throws:
        `AuthorizationException`

    - #### checkAuthorization

          public void checkAuthorization​(String topoName,
                                         Map<String,​Object> topoConf,
                                         String operation,
                                         ReqContext context)
                                  throws AuthorizationException

      Throws:
        `AuthorizationException`

    - #### filterAuthorized

          public Set<String> filterAuthorized​(String operation,
                                              Collection<String> topoIds)
                                       throws NotAliveException,
                                              AuthorizationException,
                                              IOException

      Throws:
        `NotAliveException`
        `AuthorizationException`
        `IOException`

    - #### rmDependencyJarsInTopology

          public void rmDependencyJarsInTopology​(String topoId)

    - #### rmTopologyKeys

          public void rmTopologyKeys​(String topoId)

    - #### forceDeleteTopoDistDir

          public void forceDeleteTopoDistDir​(String topoId)
                                      throws IOException

      Throws:
        `IOException`

    - #### doCleanup

          public void doCleanup()

      Cleanup topologies and Jars.

    - #### awaitLeadership

          public boolean awaitLeadership​(long timeout,
                                         TimeUnit timeUnit)
                                  throws InterruptedException

      Throws:
        `InterruptedException`

    - #### submitTopology

          public void submitTopology​(String name,
                                     String uploadedJarLocation,
                                     String jsonConf,
                                     StormTopology topology)
                              throws AlreadyAliveException,
                                     InvalidTopologyException,
                                     AuthorizationException,
                                     org.apache.storm.thrift.TException

      Specified by:
        `submitTopology` in interface `Nimbus.Iface`
      Throws:
        `AlreadyAliveException`
        `InvalidTopologyException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### submitTopologyWithOpts

          public void submitTopologyWithOpts​(String topoName,
                                             String uploadedJarLocation,
                                             String jsonConf,
                                             StormTopology topology,
                                             SubmitOptions options)
                                      throws AlreadyAliveException,
                                             InvalidTopologyException,
                                             AuthorizationException,
                                             org.apache.storm.thrift.TException

      Specified by:
        `submitTopologyWithOpts` in interface `Nimbus.Iface`
      Throws:
        `AlreadyAliveException`
        `InvalidTopologyException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### setUpAckerExecutorConfigs

          public static void setUpAckerExecutorConfigs​(String topoName,
                                                       Map<String,​Object> totalConfToSave,
                                                       Map<String,​Object> totalConf,
                                                       int estimatedNumWorker)

    - #### killTopology

          public void killTopology​(String name)
                            throws NotAliveException,
                                   AuthorizationException,
                                   org.apache.storm.thrift.TException

      Specified by:
        `killTopology` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### killTopologyWithOpts

          public void killTopologyWithOpts​(String topoName,
                                           KillOptions options)
                                    throws NotAliveException,
                                           AuthorizationException,
                                           org.apache.storm.thrift.TException

      Specified by:
        `killTopologyWithOpts` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### activate

          public void activate​(String topoName)
                        throws NotAliveException,
                               AuthorizationException,
                               org.apache.storm.thrift.TException

      Specified by:
        `activate` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### deactivate

          public void deactivate​(String topoName)
                          throws NotAliveException,
                                 AuthorizationException,
                                 org.apache.storm.thrift.TException

      Specified by:
        `deactivate` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### rebalance

          public void rebalance​(String topoName,
                                RebalanceOptions options)
                         throws NotAliveException,
                                InvalidTopologyException,
                                AuthorizationException,
                                org.apache.storm.thrift.TException

      Specified by:
        `rebalance` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `InvalidTopologyException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### setLogConfig

          public void setLogConfig​(String topoId,
                                   LogConfig config)
                            throws org.apache.storm.thrift.TException

      Specified by:
        `setLogConfig` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### getLogConfig

          public LogConfig getLogConfig​(String topoId)
                                 throws org.apache.storm.thrift.TException

      Specified by:
        `getLogConfig` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### debug

          public void debug​(String topoName,
                            String componentId,
                            boolean enable,
                            double samplingPercentage)
                     throws NotAliveException,
                            AuthorizationException,
                            org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Enable/disable logging the tuples generated in topology via an internal EventLogger bolt. The component name is optional and if null or empty, the debug flag will apply to the entire topology. The 'samplingPercentage' will limit loggging to a percentage of generated tuples.
      Specified by:
        `debug` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### setWorkerProfiler

          public void setWorkerProfiler​(String topoId,
                                        ProfileRequest profileRequest)
                                 throws org.apache.storm.thrift.TException

      Specified by:
        `setWorkerProfiler` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### getComponentPendingProfileActions

          public List<ProfileRequest> getComponentPendingProfileActions​(String id,
                                                                        String componentId,
                                                                        ProfileAction action)
                                                                 throws org.apache.storm.thrift.TException

      Specified by:
        `getComponentPendingProfileActions` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### uploadNewCredentials

          public void uploadNewCredentials​(String topoName,
                                           Credentials credentials)
                                    throws NotAliveException,
                                           InvalidTopologyException,
                                           AuthorizationException,
                                           org.apache.storm.thrift.TException

      Specified by:
        `uploadNewCredentials` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `InvalidTopologyException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### beginCreateBlob

          public String beginCreateBlob​(String key,
                                        SettableBlobMeta meta)
                                 throws AuthorizationException,
                                        KeyAlreadyExistsException,
                                        org.apache.storm.thrift.TException

      Specified by:
        `beginCreateBlob` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyAlreadyExistsException`
        `org.apache.storm.thrift.TException`

    - #### beginUpdateBlob

          public String beginUpdateBlob​(String key)
                                 throws AuthorizationException,
                                        KeyNotFoundException,
                                        org.apache.storm.thrift.TException

      Specified by:
        `beginUpdateBlob` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### uploadBlobChunk

          public void uploadBlobChunk​(String session,
                                      ByteBuffer chunk)
                               throws AuthorizationException,
                                      org.apache.storm.thrift.TException

      Specified by:
        `uploadBlobChunk` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### finishBlobUpload

          public void finishBlobUpload​(String session)
                                throws AuthorizationException,
                                       org.apache.storm.thrift.TException

      Specified by:
        `finishBlobUpload` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### cancelBlobUpload

          public void cancelBlobUpload​(String session)
                                throws AuthorizationException,
                                       org.apache.storm.thrift.TException

      Specified by:
        `cancelBlobUpload` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getBlobMeta

          public ReadableBlobMeta getBlobMeta​(String key)
                                       throws AuthorizationException,
                                              KeyNotFoundException,
                                              org.apache.storm.thrift.TException

      Specified by:
        `getBlobMeta` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### setBlobMeta

          public void setBlobMeta​(String key,
                                  SettableBlobMeta meta)
                           throws AuthorizationException,
                                  KeyNotFoundException,
                                  org.apache.storm.thrift.TException

      Specified by:
        `setBlobMeta` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### beginBlobDownload

          public BeginDownloadResult beginBlobDownload​(String key)
                                                throws AuthorizationException,
                                                       KeyNotFoundException,
                                                       org.apache.storm.thrift.TException

      Specified by:
        `beginBlobDownload` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### downloadBlobChunk

          public ByteBuffer downloadBlobChunk​(String session)
                                       throws AuthorizationException,
                                              org.apache.storm.thrift.TException

      Specified by:
        `downloadBlobChunk` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### deleteBlob

          public void deleteBlob​(String key)
                          throws AuthorizationException,
                                 KeyNotFoundException,
                                 IllegalStateException,
                                 org.apache.storm.thrift.TException

      Specified by:
        `deleteBlob` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `IllegalStateException`
        `org.apache.storm.thrift.TException`

    - #### listBlobs

          public ListBlobsResult listBlobs​(String session)
                                    throws org.apache.storm.thrift.TException

      Specified by:
        `listBlobs` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### getBlobReplication

          public int getBlobReplication​(String key)
                                 throws AuthorizationException,
                                        KeyNotFoundException,
                                        org.apache.storm.thrift.TException

      Specified by:
        `getBlobReplication` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### updateBlobReplication

          public int updateBlobReplication​(String key,
                                           int replication)
                                    throws AuthorizationException,
                                           KeyNotFoundException,
                                           org.apache.storm.thrift.TException

      Specified by:
        `updateBlobReplication` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `KeyNotFoundException`
        `org.apache.storm.thrift.TException`

    - #### createStateInZookeeper

          public void createStateInZookeeper​(String key)
                                      throws org.apache.storm.thrift.TException

      Specified by:
        `createStateInZookeeper` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### beginFileUpload

          public String beginFileUpload()
                                 throws AuthorizationException,
                                        org.apache.storm.thrift.TException

      Specified by:
        `beginFileUpload` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### uploadChunk

          public void uploadChunk​(String location,
                                  ByteBuffer chunk)
                           throws AuthorizationException,
                                  org.apache.storm.thrift.TException

      Specified by:
        `uploadChunk` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### finishFileUpload

          public void finishFileUpload​(String location)
                                throws AuthorizationException,
                                       org.apache.storm.thrift.TException

      Specified by:
        `finishFileUpload` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### downloadChunk

          public ByteBuffer downloadChunk​(String id)
                                   throws AuthorizationException,
                                          org.apache.storm.thrift.TException

      Specified by:
        `downloadChunk` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getNimbusConf

          public String getNimbusConf()
                               throws AuthorizationException,
                                      org.apache.storm.thrift.TException

      Specified by:
        `getNimbusConf` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyInfo

          public TopologyInfo getTopologyInfo​(String id)
                                       throws NotAliveException,
                                              AuthorizationException,
                                              org.apache.storm.thrift.TException

      Specified by:
        `getTopologyInfo` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyInfoByName

          public TopologyInfo getTopologyInfoByName​(String name)
                                             throws org.apache.storm.thrift.TException

      Specified by:
        `getTopologyInfoByName` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### getTopologyInfoByNameWithOpts

          public TopologyInfo getTopologyInfoByNameWithOpts​(String name,
                                                            GetInfoOptions options)
                                                     throws NotAliveException,
                                                            AuthorizationException,
                                                            org.apache.storm.thrift.TException

      Specified by:
        `getTopologyInfoByNameWithOpts` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyInfoWithOpts

          public TopologyInfo getTopologyInfoWithOpts​(String topoId,
                                                      GetInfoOptions options)
                                               throws NotAliveException,
                                                      AuthorizationException,
                                                      org.apache.storm.thrift.TException

      Specified by:
        `getTopologyInfoWithOpts` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyPageInfo

          public TopologyPageInfo getTopologyPageInfo​(String topoId,
                                                      String window,
                                                      boolean includeSys)
                                               throws NotAliveException,
                                                      AuthorizationException,
                                                      org.apache.storm.thrift.TException

      Specified by:
        `getTopologyPageInfo` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getSupervisorPageInfo

          public SupervisorPageInfo getSupervisorPageInfo​(String superId,
                                                          String host,
                                                          boolean includeSys)
                                                   throws NotAliveException,
                                                          AuthorizationException,
                                                          org.apache.storm.thrift.TException

      Specified by:
        `getSupervisorPageInfo` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getComponentPageInfo

          public ComponentPageInfo getComponentPageInfo​(String topoId,
                                                        String componentId,
                                                        String window,
                                                        boolean includeSys)
                                                 throws NotAliveException,
                                                        AuthorizationException,
                                                        org.apache.storm.thrift.TException

      Specified by:
        `getComponentPageInfo` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyConf

          public String getTopologyConf​(String id)
                                 throws NotAliveException,
                                        AuthorizationException,
                                        org.apache.storm.thrift.TException

      Specified by:
        `getTopologyConf` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopology

          public StormTopology getTopology​(String id)
                                    throws NotAliveException,
                                           AuthorizationException,
                                           org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Returns the compiled topology that contains ackers and metrics consumsers. Compare `Nimbus.Iface.getUserTopology(String id)`.
      Specified by:
        `getTopology` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getUserTopology

          public StormTopology getUserTopology​(String id)
                                        throws NotAliveException,
                                               AuthorizationException,
                                               org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Returns the user specified topology as submitted originally. Compare `Nimbus.Iface.getTopology(String id)`.
      Specified by:
        `getUserTopology` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologyHistory

          public TopologyHistoryInfo getTopologyHistory​(String user)
                                                 throws AuthorizationException,
                                                        org.apache.storm.thrift.TException

      Specified by:
        `getTopologyHistory` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getClusterInfo

          public ClusterSummary getClusterInfo()
                                        throws AuthorizationException,
                                               org.apache.storm.thrift.TException

      Specified by:
        `getClusterInfo` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologySummaries

          public List<TopologySummary> getTopologySummaries()
                                                     throws AuthorizationException,
                                                            org.apache.storm.thrift.TException

      Specified by:
        `getTopologySummaries` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologySummaryByName

          public TopologySummary getTopologySummaryByName​(String name)
                                                   throws NotAliveException,
                                                          AuthorizationException,
                                                          org.apache.storm.thrift.TException

      Specified by:
        `getTopologySummaryByName` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getTopologySummary

          public TopologySummary getTopologySummary​(String id)
                                             throws NotAliveException,
                                                    AuthorizationException,
                                                    org.apache.storm.thrift.TException

      Specified by:
        `getTopologySummary` in interface `Nimbus.Iface`
      Throws:
        `NotAliveException`
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getLeader

          public NimbusSummary getLeader()
                                  throws AuthorizationException,
                                         org.apache.storm.thrift.TException

      Specified by:
        `getLeader` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### isTopologyNameAllowed

          public boolean isTopologyNameAllowed​(String name)
                                        throws AuthorizationException,
                                               org.apache.storm.thrift.TException

      Specified by:
        `isTopologyNameAllowed` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getOwnerResourceSummaries

          public List<OwnerResourceSummary> getOwnerResourceSummaries​(String owner)
                                                               throws AuthorizationException,
                                                                      org.apache.storm.thrift.TException

      Specified by:
        `getOwnerResourceSummaries` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### getSupervisorAssignments

          public SupervisorAssignments getSupervisorAssignments​(String nodeId)
                                                         throws AuthorizationException,
                                                                org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Get assigned assignments for a specific supervisor
      Specified by:
        `getSupervisorAssignments` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### sendSupervisorWorkerHeartbeats

          public void sendSupervisorWorkerHeartbeats​(SupervisorWorkerHeartbeats heartbeats)
                                              throws AuthorizationException,
                                                     org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Send supervisor worker heartbeats for a specific supervisor
      Specified by:
        `sendSupervisorWorkerHeartbeats` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### sendSupervisorWorkerHeartbeat

          public void sendSupervisorWorkerHeartbeat​(SupervisorWorkerHeartbeat hb)
                                             throws AuthorizationException,
                                                    org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Send supervisor local worker heartbeat when a supervisor is unreachable
      Specified by:
        `sendSupervisorWorkerHeartbeat` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`

    - #### shutdown

          public void shutdown()

      Specified by:
        `shutdown` in interface `Shutdownable`

    - #### isWaiting

          public boolean isWaiting()

      Specified by:
        `isWaiting` in interface `DaemonCommon`

    - #### processWorkerMetrics

          public void processWorkerMetrics​(WorkerMetrics metrics)
                                    throws org.apache.storm.thrift.TException

      Specified by:
        `processWorkerMetrics` in interface `Nimbus.Iface`
      Throws:
        `org.apache.storm.thrift.TException`

    - #### isRemoteBlobExists

          public boolean isRemoteBlobExists​(String blobKey)
                                     throws AuthorizationException,
                                            org.apache.storm.thrift.TException

      Description copied from interface: `Nimbus.Iface`
      Decide if the blob is removed from cluster.
      Specified by:
        `isRemoteBlobExists` in interface `Nimbus.Iface`
      Throws:
        `AuthorizationException`
        `org.apache.storm.thrift.TException`